if __name__ != "__main__":
    raise Exception("This script can't be used as a module.")

import argparse
import json
import textwrap

parser = argparse.ArgumentParser(
    description="Generate a rust module from the ISO 3166 JSON data file."
)
parser.add_argument("data", help="The input ISO 3166 JSON data file.")
parser.add_argument(
    "output", help="The file path at which the module should be output."
)
parser.add_argument(
    "-l",
    "--log-level",
    default="info",
    help="The level at which to print log messages.",
)

arguments = parser.parse_args()


with open(arguments.data) as f:
    data = json.load(f)

with open(arguments.output, "w") as f:
    print(
        textwrap.dedent(
            """
            // THIS FILE IS AUTOGENERATED, DO NOT EDIT IT MANUALLY!

            use super::Alpha2;
            use super::Alpha3;
            use super::Numeric;
            use super::Country;
            use super::AreaCode;
            use super::Area;

            macro_rules! unwrap {
                ($expression:expr) => {
                    match $expression {
                        Ok(value) => value,
                        Err(_) => panic!("Called `unwrap` on an error value."),
                    }
                }
            }
        """
        ),
        file=f,
    )

    for (alpha2, country) in sorted(data.items(), key=lambda el: el[0]):
        alpha3 = country["alpha3"]
        numeric = country["numeric"]
        name = country.get("isoname", country["name"])

        print(
            textwrap.dedent(
                f"""
                pub const {alpha2}: Country = Country {{
                    alpha2: unwrap!(Alpha2::new(\"{alpha2}\")),
                    alpha3: unwrap!(Alpha3::new(\"{alpha3}\")),
                    numeric: unwrap!(Numeric::new(\"{numeric}\")),
                    name: "{name}",
                }};
            """
            ),
            file=f,
        )

        areas = country["areas"]
        language = areas.get("defaultlang", areas.get("lang"))

        for (code, area) in sorted(areas.items(), key=lambda el: el[0]):
            if code == "defaultlang" or code == "lang":
                continue

            if "isonames" in area and language in area["isonames"]:
                name = area["isonames"][language]
            else:
                name = area.get("isoname", area["name"])

            print(
                textwrap.dedent(
                    f"""
                    pub const {alpha2}_{code}: Area = Area {{
                        code: unwrap!(AreaCode::new("{code}")),
                        name: "{name}",
                    }};
                """
                ),
                file=f,
            )

    print(
        "pub static ALPHA2_COUNTRY: phf::Map<&str, &Country> = phf::phf_map! {",
        file=f,
    )
    for alpha2 in sorted(data.keys()):
        print(f'    "{alpha2}" => &{alpha2},', file=f)
    print("};", file=f)

    print(
        "pub static ALPHA3_COUNTRY: phf::Map<&str, &Country> = phf::phf_map! {",
        file=f,
    )
    for (alpha2, country) in sorted(data.items(), key=lambda el: el[0]):
        print('    "{0}" => &{1},'.format(country["alpha3"], alpha2), file=f)
    print("};", file=f)

    print(
        "pub static NUMERIC_COUNTRY: phf::Map<&str, &Country> = phf::phf_map! {",
        file=f,
    )
    for (alpha2, country) in sorted(data.items(), key=lambda el: el[0]):
        print('    "{0}" => &{1},'.format(country["numeric"], alpha2), file=f)
    print("};", file=f)

    print("pub static COUNTRIES: &[&Country] = &[", file=f)
    for alpha2 in sorted(data.keys()):
        print(f"    &{alpha2},", file=f)
    print("];", file=f)

    for (alpha2, country) in sorted(data.items(), key=lambda el: el[0]):
        print(
            f"pub static {alpha2}_AREA: phf::Map<&str, &Area> = phf::phf_map! {{",
            file=f,
        )
        for code in sorted(country["areas"].keys()):
            if code == "defaultlang" or code == "lang":
                continue

            print(f'    "{code}" => &{alpha2}_{code},', file=f)
        print("};", file=f)

    print(
        "pub static ALPHA2_CODE_AREA: phf::Map<&str, &phf::Map<&str, &Area>> = phf::phf_map! {",
        file=f,
    )
    for alpha2 in sorted(data.keys()):
        print(f'    "{alpha2}" => &{alpha2}_AREA,', file=f)
    print("};", file=f)
